<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CCFinancingCollection StructType
 * @subpackage Structs
 */
class CCFinancingCollection extends AbstractStructBase
{
    /**
     * The Show
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Show;
    /**
     * The Deposit
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Deposit;
    /**
     * The Apr
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $Apr;
    /**
     * The MinDuration
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $MinDuration;
    /**
     * The MaxDuration
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $MaxDuration;
    /**
     * Constructor method for CCFinancingCollection
     * @uses CCFinancingCollection::setShow()
     * @uses CCFinancingCollection::setDeposit()
     * @uses CCFinancingCollection::setApr()
     * @uses CCFinancingCollection::setMinDuration()
     * @uses CCFinancingCollection::setMaxDuration()
     * @param bool $show
     * @param float $deposit
     * @param float $apr
     * @param int $minDuration
     * @param int $maxDuration
     */
    public function __construct($show = null, $deposit = null, $apr = null, $minDuration = null, $maxDuration = null)
    {
        $this
            ->setShow($show)
            ->setDeposit($deposit)
            ->setApr($apr)
            ->setMinDuration($minDuration)
            ->setMaxDuration($maxDuration);
    }
    /**
     * Get Show value
     * @return bool
     */
    public function getShow()
    {
        return $this->Show;
    }
    /**
     * Set Show value
     * @param bool $show
     * @return \StructType\CCFinancingCollection
     */
    public function setShow($show = null)
    {
        $this->Show = $show;
        return $this;
    }
    /**
     * Get Deposit value
     * @return float
     */
    public function getDeposit()
    {
        return $this->Deposit;
    }
    /**
     * Set Deposit value
     * @param float $deposit
     * @return \StructType\CCFinancingCollection
     */
    public function setDeposit($deposit = null)
    {
        $this->Deposit = $deposit;
        return $this;
    }
    /**
     * Get Apr value
     * @return float
     */
    public function getApr()
    {
        return $this->Apr;
    }
    /**
     * Set Apr value
     * @param float $apr
     * @return \StructType\CCFinancingCollection
     */
    public function setApr($apr = null)
    {
        $this->Apr = $apr;
        return $this;
    }
    /**
     * Get MinDuration value
     * @return int
     */
    public function getMinDuration()
    {
        return $this->MinDuration;
    }
    /**
     * Set MinDuration value
     * @param int $minDuration
     * @return \StructType\CCFinancingCollection
     */
    public function setMinDuration($minDuration = null)
    {
        // validation for constraint: int
        if (!is_null($minDuration) && !is_numeric($minDuration)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($minDuration)), __LINE__);
        }
        $this->MinDuration = $minDuration;
        return $this;
    }
    /**
     * Get MaxDuration value
     * @return int
     */
    public function getMaxDuration()
    {
        return $this->MaxDuration;
    }
    /**
     * Set MaxDuration value
     * @param int $maxDuration
     * @return \StructType\CCFinancingCollection
     */
    public function setMaxDuration($maxDuration = null)
    {
        // validation for constraint: int
        if (!is_null($maxDuration) && !is_numeric($maxDuration)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($maxDuration)), __LINE__);
        }
        $this->MaxDuration = $maxDuration;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CCFinancingCollection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
