<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DimensionsCollection StructType
 * @subpackage Structs
 */
class DimensionsCollection extends AbstractStructBase
{
    /**
     * The Height
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $Height;
    /**
     * The Width
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $Width;
    /**
     * The Length
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $Length;
    /**
     * The Wheelebase
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $Wheelebase;
    /**
     * The Lift
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $Lift;
    /**
     * The Volume
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $Volume;
    /**
     * The BedHeight
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $BedHeight;
    /**
     * The BedWidth
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $BedWidth;
    /**
     * The BedLength
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $BedLength;
    /**
     * Constructor method for DimensionsCollection
     * @uses DimensionsCollection::setHeight()
     * @uses DimensionsCollection::setWidth()
     * @uses DimensionsCollection::setLength()
     * @uses DimensionsCollection::setWheelebase()
     * @uses DimensionsCollection::setLift()
     * @uses DimensionsCollection::setVolume()
     * @uses DimensionsCollection::setBedHeight()
     * @uses DimensionsCollection::setBedWidth()
     * @uses DimensionsCollection::setBedLength()
     * @param int $height
     * @param int $width
     * @param int $length
     * @param int $wheelebase
     * @param int $lift
     * @param int $volume
     * @param int $bedHeight
     * @param int $bedWidth
     * @param int $bedLength
     */
    public function __construct($height = null, $width = null, $length = null, $wheelebase = null, $lift = null, $volume = null, $bedHeight = null, $bedWidth = null, $bedLength = null)
    {
        $this
            ->setHeight($height)
            ->setWidth($width)
            ->setLength($length)
            ->setWheelebase($wheelebase)
            ->setLift($lift)
            ->setVolume($volume)
            ->setBedHeight($bedHeight)
            ->setBedWidth($bedWidth)
            ->setBedLength($bedLength);
    }
    /**
     * Get Height value
     * @return int|null
     */
    public function getHeight()
    {
        return $this->Height;
    }
    /**
     * Set Height value
     * @param int $height
     * @return \StructType\DimensionsCollection
     */
    public function setHeight($height = null)
    {
        // validation for constraint: int
        if (!is_null($height) && !is_numeric($height)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($height)), __LINE__);
        }
        $this->Height = $height;
        return $this;
    }
    /**
     * Get Width value
     * @return int|null
     */
    public function getWidth()
    {
        return $this->Width;
    }
    /**
     * Set Width value
     * @param int $width
     * @return \StructType\DimensionsCollection
     */
    public function setWidth($width = null)
    {
        // validation for constraint: int
        if (!is_null($width) && !is_numeric($width)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($width)), __LINE__);
        }
        $this->Width = $width;
        return $this;
    }
    /**
     * Get Length value
     * @return int|null
     */
    public function getLength()
    {
        return $this->Length;
    }
    /**
     * Set Length value
     * @param int $length
     * @return \StructType\DimensionsCollection
     */
    public function setLength($length = null)
    {
        // validation for constraint: int
        if (!is_null($length) && !is_numeric($length)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($length)), __LINE__);
        }
        $this->Length = $length;
        return $this;
    }
    /**
     * Get Wheelebase value
     * @return int|null
     */
    public function getWheelebase()
    {
        return $this->Wheelebase;
    }
    /**
     * Set Wheelebase value
     * @param int $wheelebase
     * @return \StructType\DimensionsCollection
     */
    public function setWheelebase($wheelebase = null)
    {
        // validation for constraint: int
        if (!is_null($wheelebase) && !is_numeric($wheelebase)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($wheelebase)), __LINE__);
        }
        $this->Wheelebase = $wheelebase;
        return $this;
    }
    /**
     * Get Lift value
     * @return int|null
     */
    public function getLift()
    {
        return $this->Lift;
    }
    /**
     * Set Lift value
     * @param int $lift
     * @return \StructType\DimensionsCollection
     */
    public function setLift($lift = null)
    {
        // validation for constraint: int
        if (!is_null($lift) && !is_numeric($lift)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($lift)), __LINE__);
        }
        $this->Lift = $lift;
        return $this;
    }
    /**
     * Get Volume value
     * @return int|null
     */
    public function getVolume()
    {
        return $this->Volume;
    }
    /**
     * Set Volume value
     * @param int $volume
     * @return \StructType\DimensionsCollection
     */
    public function setVolume($volume = null)
    {
        // validation for constraint: int
        if (!is_null($volume) && !is_numeric($volume)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($volume)), __LINE__);
        }
        $this->Volume = $volume;
        return $this;
    }
    /**
     * Get BedHeight value
     * @return int|null
     */
    public function getBedHeight()
    {
        return $this->BedHeight;
    }
    /**
     * Set BedHeight value
     * @param int $bedHeight
     * @return \StructType\DimensionsCollection
     */
    public function setBedHeight($bedHeight = null)
    {
        // validation for constraint: int
        if (!is_null($bedHeight) && !is_numeric($bedHeight)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($bedHeight)), __LINE__);
        }
        $this->BedHeight = $bedHeight;
        return $this;
    }
    /**
     * Get BedWidth value
     * @return int|null
     */
    public function getBedWidth()
    {
        return $this->BedWidth;
    }
    /**
     * Set BedWidth value
     * @param int $bedWidth
     * @return \StructType\DimensionsCollection
     */
    public function setBedWidth($bedWidth = null)
    {
        // validation for constraint: int
        if (!is_null($bedWidth) && !is_numeric($bedWidth)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($bedWidth)), __LINE__);
        }
        $this->BedWidth = $bedWidth;
        return $this;
    }
    /**
     * Get BedLength value
     * @return int|null
     */
    public function getBedLength()
    {
        return $this->BedLength;
    }
    /**
     * Set BedLength value
     * @param int $bedLength
     * @return \StructType\DimensionsCollection
     */
    public function setBedLength($bedLength = null)
    {
        // validation for constraint: int
        if (!is_null($bedLength) && !is_numeric($bedLength)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($bedLength)), __LINE__);
        }
        $this->BedLength = $bedLength;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DimensionsCollection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
