<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FilterCollection StructType
 * @subpackage Structs
 */
class FilterCollection extends AbstractStructBase
{
    /**
     * The BaseValue
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Vehicle
     */
    public $BaseValue;
    /**
     * The MinValue
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Vehicle
     */
    public $MinValue;
    /**
     * The MaxValue
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Vehicle
     */
    public $MaxValue;
    /**
     * Constructor method for FilterCollection
     * @uses FilterCollection::setBaseValue()
     * @uses FilterCollection::setMinValue()
     * @uses FilterCollection::setMaxValue()
     * @param \StructType\Vehicle $baseValue
     * @param \StructType\Vehicle $minValue
     * @param \StructType\Vehicle $maxValue
     */
    public function __construct(\StructType\Vehicle $baseValue = null, \StructType\Vehicle $minValue = null, \StructType\Vehicle $maxValue = null)
    {
        $this
            ->setBaseValue($baseValue)
            ->setMinValue($minValue)
            ->setMaxValue($maxValue);
    }
    /**
     * Get BaseValue value
     * @return \StructType\Vehicle|null
     */
    public function getBaseValue()
    {
        return $this->BaseValue;
    }
    /**
     * Set BaseValue value
     * @param \StructType\Vehicle $baseValue
     * @return \StructType\FilterCollection
     */
    public function setBaseValue(\StructType\Vehicle $baseValue = null)
    {
        $this->BaseValue = $baseValue;
        return $this;
    }
    /**
     * Get MinValue value
     * @return \StructType\Vehicle|null
     */
    public function getMinValue()
    {
        return $this->MinValue;
    }
    /**
     * Set MinValue value
     * @param \StructType\Vehicle $minValue
     * @return \StructType\FilterCollection
     */
    public function setMinValue(\StructType\Vehicle $minValue = null)
    {
        $this->MinValue = $minValue;
        return $this;
    }
    /**
     * Get MaxValue value
     * @return \StructType\Vehicle|null
     */
    public function getMaxValue()
    {
        return $this->MaxValue;
    }
    /**
     * Set MaxValue value
     * @param \StructType\Vehicle $maxValue
     * @return \StructType\FilterCollection
     */
    public function setMaxValue(\StructType\Vehicle $maxValue = null)
    {
        $this->MaxValue = $maxValue;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FilterCollection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
