<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FreetextCollection StructType
 * @subpackage Structs
 */
class FreetextCollection extends AbstractStructBase
{
    /**
     * The Default
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Default;
    /**
     * The Intern
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Intern;
    /**
     * The Hpm
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Hpm;
    /**
     * The HpmShow
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $HpmShow;
    /**
     * The Dealer
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Dealer;
    /**
     * The CarApi
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CarApi;
    /**
     * The Formated
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Formated;
    /**
     * Constructor method for FreetextCollection
     * @uses FreetextCollection::setDefault()
     * @uses FreetextCollection::setIntern()
     * @uses FreetextCollection::setHpm()
     * @uses FreetextCollection::setHpmShow()
     * @uses FreetextCollection::setDealer()
     * @uses FreetextCollection::setCarApi()
     * @uses FreetextCollection::setFormated()
     * @param string $default
     * @param string $intern
     * @param string $hpm
     * @param bool $hpmShow
     * @param string $dealer
     * @param string $carApi
     * @param string $formated
     */
    public function __construct($default = null, $intern = null, $hpm = null, $hpmShow = null, $dealer = null, $carApi = null, $formated = null)
    {
        $this
            ->setDefault($default)
            ->setIntern($intern)
            ->setHpm($hpm)
            ->setHpmShow($hpmShow)
            ->setDealer($dealer)
            ->setCarApi($carApi)
            ->setFormated($formated);
    }
    /**
     * Get Default value
     * @return string|null
     */
    public function getDefault()
    {
        return $this->Default;
    }
    /**
     * Set Default value
     * @param string $default
     * @return \StructType\FreetextCollection
     */
    public function setDefault($default = null)
    {
        // validation for constraint: string
        if (!is_null($default) && !is_string($default)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($default)), __LINE__);
        }
        $this->Default = $default;
        return $this;
    }
    /**
     * Get Intern value
     * @return string|null
     */
    public function getIntern()
    {
        return $this->Intern;
    }
    /**
     * Set Intern value
     * @param string $intern
     * @return \StructType\FreetextCollection
     */
    public function setIntern($intern = null)
    {
        // validation for constraint: string
        if (!is_null($intern) && !is_string($intern)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($intern)), __LINE__);
        }
        $this->Intern = $intern;
        return $this;
    }
    /**
     * Get Hpm value
     * @return string|null
     */
    public function getHpm()
    {
        return $this->Hpm;
    }
    /**
     * Set Hpm value
     * @param string $hpm
     * @return \StructType\FreetextCollection
     */
    public function setHpm($hpm = null)
    {
        // validation for constraint: string
        if (!is_null($hpm) && !is_string($hpm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($hpm)), __LINE__);
        }
        $this->Hpm = $hpm;
        return $this;
    }
    /**
     * Get HpmShow value
     * @return bool|null
     */
    public function getHpmShow()
    {
        return $this->HpmShow;
    }
    /**
     * Set HpmShow value
     * @param bool $hpmShow
     * @return \StructType\FreetextCollection
     */
    public function setHpmShow($hpmShow = null)
    {
        $this->HpmShow = $hpmShow;
        return $this;
    }
    /**
     * Get Dealer value
     * @return string|null
     */
    public function getDealer()
    {
        return $this->Dealer;
    }
    /**
     * Set Dealer value
     * @param string $dealer
     * @return \StructType\FreetextCollection
     */
    public function setDealer($dealer = null)
    {
        // validation for constraint: string
        if (!is_null($dealer) && !is_string($dealer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dealer)), __LINE__);
        }
        $this->Dealer = $dealer;
        return $this;
    }
    /**
     * Get CarApi value
     * @return string|null
     */
    public function getCarApi()
    {
        return $this->CarApi;
    }
    /**
     * Set CarApi value
     * @param string $carApi
     * @return \StructType\FreetextCollection
     */
    public function setCarApi($carApi = null)
    {
        // validation for constraint: string
        if (!is_null($carApi) && !is_string($carApi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($carApi)), __LINE__);
        }
        $this->CarApi = $carApi;
        return $this;
    }
    /**
     * Get Formated value
     * @return string|null
     */
    public function getFormated()
    {
        return $this->Formated;
    }
    /**
     * Set Formated value
     * @param string $formated
     * @return \StructType\FreetextCollection
     */
    public function setFormated($formated = null)
    {
        // validation for constraint: string
        if (!is_null($formated) && !is_string($formated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($formated)), __LINE__);
        }
        $this->Formated = $formated;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FreetextCollection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
