<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FuelConsumptionCollection StructType
 * @subpackage Structs
 */
class FuelConsumptionCollection extends AbstractStructBase
{
    /**
     * The City
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var float
     */
    public $City;
    /**
     * The Country
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var float
     */
    public $Country;
    /**
     * The Combined
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var float
     */
    public $Combined;
    /**
     * Constructor method for FuelConsumptionCollection
     * @uses FuelConsumptionCollection::setCity()
     * @uses FuelConsumptionCollection::setCountry()
     * @uses FuelConsumptionCollection::setCombined()
     * @param float $city
     * @param float $country
     * @param float $combined
     */
    public function __construct($city = null, $country = null, $combined = null)
    {
        $this
            ->setCity($city)
            ->setCountry($country)
            ->setCombined($combined);
    }
    /**
     * Get City value
     * @return float|null
     */
    public function getCity()
    {
        return $this->City;
    }
    /**
     * Set City value
     * @param float $city
     * @return \StructType\FuelConsumptionCollection
     */
    public function setCity($city = null)
    {
        $this->City = $city;
        return $this;
    }
    /**
     * Get Country value
     * @return float|null
     */
    public function getCountry()
    {
        return $this->Country;
    }
    /**
     * Set Country value
     * @param float $country
     * @return \StructType\FuelConsumptionCollection
     */
    public function setCountry($country = null)
    {
        $this->Country = $country;
        return $this;
    }
    /**
     * Get Combined value
     * @return float|null
     */
    public function getCombined()
    {
        return $this->Combined;
    }
    /**
     * Set Combined value
     * @param float $combined
     * @return \StructType\FuelConsumptionCollection
     */
    public function setCombined($combined = null)
    {
        $this->Combined = $combined;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FuelConsumptionCollection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
