<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PictureTypeCollection StructType
 * @subpackage Structs
 */
class PictureTypeCollection extends AbstractStructBase
{
    /**
     * The Full
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\PictureType
     */
    public $Full;
    /**
     * The Medium
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\PictureType
     */
    public $Medium;
    /**
     * The Small
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\PictureType
     */
    public $Small;
    /**
     * The Preview
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\PictureType
     */
    public $Preview;
    /**
     * Constructor method for PictureTypeCollection
     * @uses PictureTypeCollection::setFull()
     * @uses PictureTypeCollection::setMedium()
     * @uses PictureTypeCollection::setSmall()
     * @uses PictureTypeCollection::setPreview()
     * @param \StructType\PictureType $full
     * @param \StructType\PictureType $medium
     * @param \StructType\PictureType $small
     * @param \StructType\PictureType $preview
     */
    public function __construct(\StructType\PictureType $full = null, \StructType\PictureType $medium = null, \StructType\PictureType $small = null, \StructType\PictureType $preview = null)
    {
        $this
            ->setFull($full)
            ->setMedium($medium)
            ->setSmall($small)
            ->setPreview($preview);
    }
    /**
     * Get Full value
     * @return \StructType\PictureType
     */
    public function getFull()
    {
        return $this->Full;
    }
    /**
     * Set Full value
     * @param \StructType\PictureType $full
     * @return \StructType\PictureTypeCollection
     */
    public function setFull(\StructType\PictureType $full = null)
    {
        $this->Full = $full;
        return $this;
    }
    /**
     * Get Medium value
     * @return \StructType\PictureType
     */
    public function getMedium()
    {
        return $this->Medium;
    }
    /**
     * Set Medium value
     * @param \StructType\PictureType $medium
     * @return \StructType\PictureTypeCollection
     */
    public function setMedium(\StructType\PictureType $medium = null)
    {
        $this->Medium = $medium;
        return $this;
    }
    /**
     * Get Small value
     * @return \StructType\PictureType
     */
    public function getSmall()
    {
        return $this->Small;
    }
    /**
     * Set Small value
     * @param \StructType\PictureType $small
     * @return \StructType\PictureTypeCollection
     */
    public function setSmall(\StructType\PictureType $small = null)
    {
        $this->Small = $small;
        return $this;
    }
    /**
     * Get Preview value
     * @return \StructType\PictureType
     */
    public function getPreview()
    {
        return $this->Preview;
    }
    /**
     * Set Preview value
     * @param \StructType\PictureType $preview
     * @return \StructType\PictureTypeCollection
     */
    public function setPreview(\StructType\PictureType $preview = null)
    {
        $this->Preview = $preview;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PictureTypeCollection
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
